import * as React from "react";
import { IDropObj, Idrop, ICheckboxCom, getNodeType } from "./combo";
declare enum activeStatus {
    select = "selected",
    hasSelect = "hasSelect",
    noSelect = "noSelect"
}
type comboType = keyof IDropObj;
type props<P extends comboType, K> = {
    node: getNodeType<P, K>;
    fieldObj: Idrop<P, K>["filedObj"];
    index: string;
    lev?: number;
    CheckBox?: React.ComponentType<ICheckboxCom>;
    checkMethod?: (value: string) => void;
    formatterDropItem?: Idrop<P, K>["formatterDropItem"];
    clickFn(index: string): void;
};
type states = {};
interface IDropItem {
    getCheckbox(text: string, icon: JSX.Element | undefined): JSX.Element;
}
declare class DropItem<P extends comboType, T extends AnyObj> extends React.PureComponent<props<P, T>, states> implements IDropItem {
    state: states;
    checkFn: (e: React.ChangeEvent<HTMLInputElement>) => void;
    getCheckbox(text: React.ReactNode, icon: JSX.Element | undefined): React.JSX.Element;
    clickFn: (e: React.MouseEvent<HTMLDivElement>) => void;
    render(): React.JSX.Element;
}
export { DropItem, activeStatus };
