import * as React from "react";
import { ICommon } from "./mytablist";
import { IScrollMethods } from "../../scroll/scroll";
type Props<T> = {
    data: ICommon<T>["data"];
    isreLoad: AnyObj;
    theadChild: ICommon<T>["groupCol"]["children"];
    config: ICommon<T>["config"];
    fixObj: ICommon<T>["fixObj"];
    viewIndex: number;
    startIndex: number;
    originScroll?: boolean;
    changeState: ICommon<T>["changeState"];
    changeScrollTop(top: number, viewIndex: number): void;
    setTabBodyDom(dom: HTMLElement, viewIndex: number, scrollFn?: IScrollMethods): void;
};
type States = {};
interface ITabView {
    overBox(): void;
    wheelFn(e: WheelEvent): void;
    makeSign(e: React.MouseEvent<HTMLDivElement>): void;
}
declare class TabView<T extends AnyObj> extends React.PureComponent<Props<T>, States> implements ITabView {
    state: States;
    colHeadRef: React.RefObject<HTMLDivElement>;
    tabBodyRef: React.RefObject<HTMLDivElement>;
    scrollBoxMethod: IScrollMethods | undefined;
    bindScrollboxFn: (method?: IScrollMethods) => void;
    originScrollFn: (e: React.UIEvent<HTMLDivElement>) => void;
    overBox(): void;
    wheelFn: (e: WheelEvent) => void;
    makeSign: (e: React.MouseEvent<HTMLDivElement>) => void;
    checkAll: (e: React.MouseEvent<HTMLSpanElement>) => void;
    getCheckAll(): React.JSX.Element;
    gethead(): React.JSX.Element;
    createColgroup(): React.JSX.Element;
    componentDidMount(): void;
    componentWillUnmount(): void;
    getBody(): React.JSX.Element;
    scrollCallback: (value: number, isVertical: boolean) => void;
    componentDidUpdate(preProps: Props<T>): void;
    render(): React.JSX.Element;
}
export default TabView;
