import * as React from "react";
import { ICommon, TreeTabNode } from "./mytreeTable";
type Props<T extends AnyObj> = {
    cols: ICommon<T>["col"][];
    node: TreeTabNode<ICommon<T>["node"]>;
    fixObj: ICommon<T>["fixObj"];
    lev: number;
    index: string;
    order: string;
    isPar?: boolean;
    isMainView?: boolean;
    changeState: ICommon<T>["changeState"];
};
type States = {};
interface IItem {
    getFirstText(text: string, show: boolean): JSX.Element;
}
declare class Item<T extends AnyObj> extends React.PureComponent<Props<T>, States> implements IItem {
    state: States;
    getCheck(): React.JSX.Element | undefined;
    slideIconEvent: (e: React.MouseEvent<HTMLDivElement>) => void;
    getIcon(): React.JSX.Element | undefined;
    clickFn: (e: React.MouseEvent<HTMLDivElement>) => void;
    checkFn: (e: React.MouseEvent<HTMLSpanElement>) => void;
    getFirstText(text: string, showOrder: boolean): React.JSX.Element;
    changeSelect: (e: React.MouseEvent<HTMLTableCellElement>) => void;
    render(): React.JSX.Element;
}
export default Item;
