import React from "react";
import { IImmutalbeMap, IImmutalbeList, ImmuTreeNode } from "../../util/immutableUtil";
export type ITabNodeOtherKey<T extends AnyObj> = Exclude<keyof T, "children">;
export type TreeTabNode<T extends AnyObj> = IImmutalbeMap<ImmuTreeNode<ICommon<T>["node"]>, ICommon<T>["node"]>;
export interface IColumnItem<T extends AnyObj> {
    field: string;
    children: React.ReactNode;
    align?: "center" | "left" | 'right';
    width: number;
    formatter?: (node: TreeTabNode<ICommon<T>["node"]>, index: number, tabField: string | undefined, field: string, order: string) => React.ReactChild;
}
type group<T extends AnyObj> = React.ComponentElement<IColumnItem<T>, React.ComponentState>;
export interface Inode {
    active: 'selected' | 'hasSelect' | 'noSelect';
    expand: boolean;
    order: string;
}
export interface ICommon<T extends AnyObj> {
    node: {
        [k in keyof (Inode & T)]: k extends keyof Inode ? Inode[k] : T[k];
    };
    data: IImmutalbeList<TreeTabNode<ICommon<T>['node']>>;
    col: (Omit<IColumnItem<T>, 'children'> & {
        text: React.ReactNode;
    });
    groupCol: {
        children: group<T>[] | group<T>;
        forzen?: boolean;
        width?: number;
    };
    config: Omit<ICommon<T>['groupCol'], 'children'> & {
        child: ICommon<T>['col'][];
        width: number;
    };
    fixObj: {
        childField: string;
        fileOrder?: boolean;
        slectField?: string;
        noOrder?: boolean;
        multiply?: boolean;
        itemIcon?: string | false | ((node: TreeTabNode<ICommon<T>["node"]>) => string);
        idField: string;
        defaultSel?: string;
        tabField?: string;
        emptyTxt?: string | ((field?: string) => React.ReactChild);
    };
    changeState(path: string, key: 'expand' | 'active' | 'checkPar'): void;
}
export type fieldObj<T extends AnyObj> = {
    column: IColumnItem<T>[];
    idField: string;
    noOrder?: boolean;
    checkbox?: boolean;
    tabField?: string;
};
export {};
