import * as React from "react";
import { IScrollMethods } from "./scroll";
type Props = {
    height?: number;
    bindIntiScroll?: (scrollMethods?: IScrollMethods) => void;
    className?: string;
    children?: React.ReactNode;
    scrollWidthAuto?: boolean;
    keepBarShow?: boolean;
    scrollCallback?: (val: number, isVertical: boolean) => void;
};
type States = {
    showHBar: boolean;
    showWBar: boolean;
    moveBarH: number;
    moveBarW: number;
};
interface IScrollBox {
    locateBarH(e: React.MouseEvent<HTMLDivElement>): void;
}
declare class ScrollBox extends React.PureComponent<Props, States> implements IScrollBox {
    static defaultProps: {
        className: string;
    };
    moveHBar: React.RefObject<HTMLDivElement>;
    moveWBar: React.RefObject<HTMLDivElement>;
    scrollMain: React.RefObject<HTMLDivElement>;
    startY: number | null;
    state: States;
    scrollBoxH: number;
    scrollBoxW: number;
    scrollMainH: number;
    scrollMainW: number;
    scrollMethods: IScrollMethods;
    timerH: number;
    timerW: number;
    upTimer: number;
    moveStartTop: number | null;
    constructor(props: Props);
    scrollToTop: (top: number) => void;
    scrollToLeft: (left: number) => void;
    barHMove: (e: MouseEvent) => void;
    barWMove: (e: MouseEvent) => void;
    barHMoveEven: (e: MouseEvent) => void;
    barWMoveEven: (e: MouseEvent) => void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    upDateInit: (defaultH?: number) => void;
    updateVertical(setH?: number): void;
    updatehorizontal(setW?: number): void;
    animateScroll(obj: {
        start: number;
        end: number;
        isVertical: boolean;
    }, callback: () => void): void;
    componentDidUpdate(prevProps: Props): void;
    barHClick: (e: React.MouseEvent<HTMLDivElement>) => void;
    barWClick: (e: React.MouseEvent<HTMLDivElement>) => void;
    cancelBarMove: () => void;
    mouseOver: (e: React.MouseEvent<HTMLDivElement> | React.TouchEvent<HTMLDivElement>) => void;
    mainMousewheel: (e: React.WheelEvent | React.TouchEvent) => void;
    locateBarH: (e: React.MouseEvent<HTMLDivElement>) => void;
    locateBarW: (e: React.MouseEvent<HTMLDivElement>) => void;
    stopProp: (e: React.MouseEvent<HTMLDivElement>) => void;
    stopWhell: <k extends Event>(e: k) => void;
    render(): React.JSX.Element;
}
export default ScrollBox;
